-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
------	SWAP - THE GAME - SACRIFICE MODDING 2010  ---------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua');
local ScenarioFramework = import('/lua/ScenarioFramework.lua');
local Utilities = import('/lua/utilities.lua');
local Entity = import('/lua/sim/Entity.lua').Entity;
local AIUtils = import('/lua/ai/aiutilities.lua');
local UIUtil = import('/lua/ui/uiutil.lua')
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')
local Group = import('/lua/maui/group.lua').Group
local Bitmap = import('/lua/maui/bitmap.lua').Bitmap

local gameEnd = false;
local beatTime = 1;
local playercount = 0;

local identitys = {};
local killCount = { ARMY_1 = 0,	ARMY_2 = 0,	ARMY_3 = 0,	ARMY_4 = 0,	ARMY_5 = 0,	ARMY_6 = 0,	
					ARMY_SUPERWEAPON = 0,
					ARMY_SURVIVAL_ENEMY = 0,
					ARMY_ALLIED = 0};

local alreadyswaptower = 0;
local runout = {0, 0, 0, 0, 0, 0};
local deadarea = 1;
local stopthewinning = 0;
local howm = 2;

function OnPopulate()

	if (ScenarioInfo.Options.opt_howm == nil) then
		ScenarioInfo.Options.opt_howm = 2;
	end
	howm = ScenarioInfo.Options.opt_howm;
	
	if (ScenarioInfo.Options.opt_zeitalive == nil) then
		ScenarioInfo.Options.opt_zeitalive = 120;
	end	
	zeitalive = ScenarioInfo.Options.opt_zeitalive;
	
	if (ScenarioInfo.Options.opt_zeitdazwischen == nil) then
		ScenarioInfo.Options.opt_zeitdazwischen = 1;
	end		
	angsthaben = ScenarioInfo.Options.opt_zeitdazwischen;
	
	ScenarioUtils.InitializeArmies();

	local armies = ListArmies();
	playercount = table.getn(armies) - 2;
	
end

function OnStart(self)

	setupGame();
	startStartThreads();
	
	for index, brain in ArmyBrains do
		brain.CalculateScore = function(thisBrain)
			return howmany(thisBrain);
		end
	end 

end

howmany = function(brain)

list = brain:GetListOfUnits(categories.IDENT , false);
howmanyis = table.getn(list);

return howmanyis

end

startStartThreads = function()

	local mainThread = ForkThread(function(self)
	
		while (gameEnd == false) do

			winorlose();
			checkfornoname();
			swapcheck();
			checkforallowedswap();
			killallindeadarea();
			hasaplayerallidentitys();
			
			WaitSeconds(beatTime);
			
		end
		
		KillThread(self);
		
    end);

end

checkfornoname = function()

	for i, army in ListArmies() do
		list = GetArmyBrain(army):GetListOfUnits(categories.COMMAND , false);
		jap = "";
		for allman, currentit in list do
		currentit:SetCustomName(jap);
		end
	end
		
end

setupGame = function()

	ScenarioInfo.Options.Victory = 'sandbox';
	--ScenarioInfo.Options.TeamLock = 'unlocked';	-- ?
	ScenarioInfo.Options.TeamSpawn = 'random';	-- ?

	SetArmyColor("ARMY_SUPERWEAPON",251,158,11);

	for i, army in ListArmies() do
	
			if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 

			SetAlliance(army, "ARMY_SURVIVAL_ENEMY", 'Enemy'); 
			SetAlliance(army, "ARMY_SUPERWEAPON", 'Neutral');
			SetAlliance(army, "ARMY_ALLIED", 'Ally');
			
			SetAlliedVictory(army, true); 
			
				for j, army2 in ListArmies() do
					if (army2 == "ARMY_1" or army2 == "ARMY_2" or army2 == "ARMY_3" or army2 == "ARMY_4" or army2 == "ARMY_5" or army2 == "ARMY_6") then 
					
						if (army2 != army)
						then
						SetAlliance(army, army2, 'Enemy'); 
						end
						
					end
				end		
			
		end
	end

	SetAlliance("ARMY_SURVIVAL_ENEMY", "ARMY_SUPERWEAPON", 'Enemy');

	spawnidentitys();
	
	local sizeX, sizeY = GetMapSize()
	local gateName = "SwapTower";
	local posiofhill = ScenarioUtils.MarkerToPosition(gateName);
	centerX = posiofhill[1];
	centerY = posiofhill[3];
	radius = sizeX/30
	CreateHill(centerX, centerY, radius)

end

killallindeadarea = function()

	if (deadarea == 1)
	then

		for j, army in ListArmies() do
		
		if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
			
			gateName = "SwapTower"
			position = ScenarioUtils.MarkerToPosition(gateName);
				
			units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.ALLUNITS, position, radius);
			
				for _, unit in units do
				
				unit:Kill();
				
				end
		end
		end

	end

end

spawnidentitys = function()

	for i, army in ListArmies() do	

		if (army == "ARMY_1")
		then
		spawnidentityforplayer(1);
		end
		
		if (army == "ARMY_2")
		then
		spawnidentityforplayer(2);
		end
		
		if (army == "ARMY_3")
		then
		spawnidentityforplayer(3);
		end
		
		if (army == "ARMY_4")
		then
		spawnidentityforplayer(4);
		end
		
		if (army == "ARMY_5")
		then
		spawnidentityforplayer(5);
		end
		
		if (army == "ARMY_6")
		then
		spawnidentityforplayer(6);
		end
		
	end

end

spawnidentityforplayer = function(player)

	local gateName = "Identity"..player;
	local pos = ScenarioUtils.MarkerToPosition(gateName);
	gateFaction = 'identity';
	identitys[player] = CreateUnitHPR( gateFaction, "ARMY_SUPERWEAPON", pos[1], pos[2], pos[3], 0,0,0);
	local bpw = identitys[player]:GetBlueprint();
	if (bpw != nil) then
		bpw.Wreckage = nil;
	end
	name = "Identity";
	identitys[player]:SetCustomName(name);
	identitys[player]:SetCanTakeDamage(false)
	identitys[player]:SetCanBeKilled(false)

end

spawnswaptower = function()

	fromhere = GetGameTimeSeconds();
	alreadyswaptower = 1;
	deadarea = 0;

	local gateName = "SwapTower";
	local pos = ScenarioUtils.MarkerToPosition(gateName);
	local bp = 'swaptower';
	
	localnewgate = CreateUnitHPR( bp, "ARMY_SUPERWEAPON", pos[1], pos[2], pos[3], 0,0,0);

	localnewgate:SetDoNotTarget(true)
	localnewgate:SetCanTakeDamage(false)
	localnewgate:SetCapturable(true)
	localnewgate:SetRegenRate(999999)

	local bpw = localnewgate:GetBlueprint();
	if (bpw != nil) then
		bpw.Wreckage = nil;
	end

end

function CreateHill(centerX, centerY, radius)

	army = "ARMY_ALLIED";

	local markerN = CreateUnitHPR("urc1901", army, centerX, 0, centerY-radius, 0, 0, 0)
	makeSafe(markerN)
	local markerE = CreateUnitHPR("urc1901", army, centerX+radius, 0, centerY, 0, 0, 0)
	makeSafe(markerE)
	local markerS = CreateUnitHPR("urc1901", army, centerX, 0, centerY+radius, 0, 0, 0)
	makeSafe(markerS)
	local markerW = CreateUnitHPR("urc1901", army, centerX-radius, 0, centerY, 0, 0, 0)
	makeSafe(markerW)
	local markerNE = CreateUnitHPR("urc1901", army, centerX+radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
	makeSafe(markerNE)
	local markerSE = CreateUnitHPR("urc1901", army, centerX+radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
	makeSafe(markerSE)
	local markerSW = CreateUnitHPR("urc1901", army, centerX-radius*math.sqrt(2)/2, 0, centerY+radius*math.sqrt(2)/2, 0, 0, 0)
	makeSafe(markerSW)
	local markerNW = CreateUnitHPR("urc1901", army, centerX-radius*math.sqrt(2)/2, 0, centerY-radius*math.sqrt(2)/2, 0, 0, 0)
	makeSafe(markerNW)

end

function makeSafe(unit)
	unit:SetCanTakeDamage(false)
	unit:SetDoNotTarget(true)
	unit:SetReclaimable(false)
	unit:SetCapturable(false)
	unit:SetIntelRadius('Vision',0);
end

checkforallowedswap = function()

	if (alreadyswaptower == 1)
	then
	
		swptow = "";
		truetime = 0;
		for j, army in ListArmies() do
			
			gateName = "SwapTower"
			position = ScenarioUtils.MarkerToPosition(gateName);
				
			units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.ALLUNITS, position, 1);
			
				for _, unit in units do
				swptow = unit;
				end

		end

		for j, army in ListArmies() do
			
		if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
		
			gateName = "SwapTower"
			position = ScenarioUtils.MarkerToPosition(gateName);
				
			units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.ALLUNITS, position, 1);
			
			howmuch = table.getn(units);
			
			if (howmuch >= 1)
			then
			truetime = 1;
			end
			
		end
		end
		
		if (swptow != "")
		then
			
		if (truetime == 1)
		then
		
		now = GetGameTimeSeconds();
		rest = now - fromhere;
		
		name = math.floor(rest);
		name = zeitalive - name;
		swptow:SetCustomName(name);

			if (rest >= zeitalive)
			then

			swptow:Kill();
			truetime = 0;
			alreadyswaptower = 0;
			deadarea = 1;
			swapit();
			
			end
	
		else
		fromhere = GetGameTimeSeconds();
		end
		
		else
		
		alreadyswaptower = 0;
		deadarea = 1;
		
		end
		
	end
		
	
end

hasaplayerallidentitys = function()

	if (stopthewinning != 1)
	then
		homup = 0;

			for i, army in ListArmies() do
				if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
						homup = homup + 1;
				end
			end

			for i, army in ListArmies() do
				if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 

				list = GetArmyBrain(army):GetListOfUnits(categories.IDENT , false);
				
					for in_, unit in list do
						unit:SetCanTakeDamage(false)
						unit:SetCanBeKilled(false)				
					end
				
				playerhatsoundsoviele = table.getn(list);
				
				if (playerhatsoundsoviele == homup)
				then
				brain = GetArmyBrain(army);
				brain:OnVictory();
				WaitSeconds(1);
				
							for j, army2 in ListArmies() do
							if (army2 != army ) then 
							
							brain2 = GetArmyBrain(army2);
							brain2:OnDefeat();
							WaitSeconds(1);
							
							end
							end
				WaitSeconds(10);
				EndGame();
				
				end
				
				end
			end
	end

end

winorlose = function()

	for i, army in ListArmies() do
		if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
			list = GetArmyBrain(army):GetListOfUnits(categories.COMMAND , false);
			iscommandthere = table.getn(list);
				if (iscommandthere == 0)
				then
				
				list = GetArmyBrain(army):GetListOfUnits(categories.IDENT , false);
				
					for index, currentunit in list do
					
					pos = currentunit:GetPosition();
					bluep = currentunit:GetUnitId();
					health = currentunit:GetHealth();
						
					currentunit:Destroy();
					
					newunit = CreateUnitHPR( bluep, "ARMY_SUPERWEAPON", pos[1], pos[2], pos[3], 0,0,0);
					newunit:SetHealth(nil, health);
						
					end
						
				
				brain = GetArmyBrain(army);
				brain:OnDefeat()
				
				end
		end
	end

end

swapcheck = function(self)

	for i, army in ListArmies() do	

		if (army == "ARMY_1")
		then
		checkswap(1);
		end
		
		if (army == "ARMY_2")
		then
		checkswap(2);
		end
		
		if (army == "ARMY_3")
		then
		checkswap(3);
		end
		
		if (army == "ARMY_4")
		then
		checkswap(4);
		end
		
		if (army == "ARMY_5")
		then
		checkswap(5);
		end
		
		if (army == "ARMY_6")
		then
		checkswap(6);
		end
		
	end

end

checkswap = function(whichidentity)

	if (alreadyswaptower == 0)
	then

	currentidentity = "";

		for j, army in ListArmies() do
		
			if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
		
			gateName = "Identity"..whichidentity;
			position = ScenarioUtils.MarkerToPosition(gateName);
			
			units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.ALLUNITS, position, 1);
		
				for _, unit in units do
				currentidentity = unit;
				end
		
			end

		end

		if (currentidentity != "")
		then
		health = currentidentity:GetHealth();
		name = "Ready";

			if (health == 1200)
			then
			
			alreadyrun = runout[whichidentity];
			
				if (alreadyrun == howm)
				then
				name = "Inactive";
				print("This Identity already activated the maximum number of SwapTower!");
				currentidentity:SetMaxHealth(1000);
				currentidentity:SetHealth(nil, 1000);				
				else
				currentidentity:SetMaxHealth(1000);
				currentidentity:SetHealth(nil, 1000);	
				runout[whichidentity] = runout[whichidentity] + 1;
				name = "Inactive";
				spawnswaptower();
				end
			
			end
			
		alreadyrun = runout[whichidentity];

		if (alreadyrun == howm)
		then
		name = "Inactive";
		end
			
		currentidentity:SetCustomName(name);

		end
		
	else

		currentidentity = "";

		for j, army in ListArmies() do
		
			if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
		
			gateName = "Identity"..whichidentity;
			position = ScenarioUtils.MarkerToPosition(gateName);
			
			units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.ALLUNITS, position, 1);
		
				for _, unit in units do
				currentidentity = unit;
				end
		
			end

		end

		if (currentidentity != "")
		then
		health = currentidentity:GetHealth();
		name = "Ready";

			if (health == 1200)
			then
			
			alreadyrun = runout[whichidentity];
			
				if (alreadyrun < howmany)
				then
				currentidentity:SetMaxHealth(1000);
				currentidentity:SetHealth(nil, 1000);
				print("There is already a SwapTower activated! Try later...");
				else
				name = "Inactive";
				print("This Identity already activated the maximum number of SwapTower!");
				currentidentity:SetMaxHealth(1000);
				currentidentity:SetHealth(nil, 1000);	
				end
				
			end

		alreadyrun = runout[whichidentity];

		if (alreadyrun == howmany)
		then
		name = "Inactive";
		end			

		currentidentity:SetCustomName(name);

		end

	end

end

function shuffletable(tt)

	--LOG('VORHER:');

	--	for everyitem, item in tt do
		
	--		LOG('allthese['..everyitem..'] = '..item);
		
	--	end

lenge = table.getn(tt);
chekc = lenge;
res = chekc;
restore = tt;

		for i = 1,lenge do
	
			where = chekc - 1;
			rando = Utilities.GetRandomInt(1,where);
			rando = math.floor(rando);
			
			toins = tt[rando];
			table.remove(tt, rando);
			table.insert(tt, toins);
			
			chekc = chekc - 1;
		
		end
		
	--LOG('NACHHER:');
	
	--	for everyitem, item in tt do
		
	--		LOG('allthese['..everyitem..'] = '..item);
		
	--	end
	
	return tt;

end

swapit = function()

howmanyplayers = 0;
allthese = {};
unitlists = {};
identlists = {};

	for i, army in ListArmies() do
		if (army == "ARMY_1" or army == "ARMY_2" or army == "ARMY_3" or army == "ARMY_4" or army == "ARMY_5" or army == "ARMY_6") then 
			list = GetArmyBrain(army):GetListOfUnits(categories.COMMAND , false);
			iscommandthere = table.getn(list);
				if (iscommandthere == 1)
				then
				howmanyplayers = howmanyplayers + 1;
				howmn = army;
				table.insert(allthese, howmn);
				end
		end
	end

	swapjaornein = Utilities.GetRandomInt(1,howmanyplayers);
	
		if (swapjaornein != 1)
		then
			WaitSeconds(angsthaben);
			killit();
			WaitSeconds(1);
			msgOut("Attention! Get ready for a swap!");
			allthese = shuffletable(allthese)
			
			for i, it in allthese do
			
			stopthewinning = 1;
			unitlists[i] = GetArmyBrain(it):GetListOfUnits(categories.ALLUNITS , false);
			
			--LOG('I:::'..i);
			--LOG('IT:::'..it);
			
			end
			
			for i = 1,howmanyplayers do
	
			if (i != howmanyplayers)
			then
				swapplayer(unitlists[i],allthese[i+1]);				
			else
				swapplayer(unitlists[i],allthese[1]);
			end
	
		end	

		stopthewinning = 0;
		
		spawnidentitys();
		
		else
		
		WaitSeconds(angsthaben);
		msgOut("Try to swap failed!");
		
		end

end

killit = function()

	for i, army in ListArmies() do	

		if (army == "ARMY_1")
		then
		killident(1);
		end
		
		if (army == "ARMY_2")
		then
		killident(2);
		end
		
		if (army == "ARMY_3")
		then
		killident(3);
		end
		
		if (army == "ARMY_4")
		then
		killident(4);
		end
		
		if (army == "ARMY_5")
		then
		killident(5);
		end
		
		if (army == "ARMY_6")
		then
		killident(6);
		end
		
	end
	
end

killident = function(whichone)

	for j, army in ListArmies() do
	
		gateName = "Identity"..whichone;
		position = ScenarioUtils.MarkerToPosition(gateName);
		
		units = AIUtils.GetOwnUnitsAroundPoint(GetArmyBrain(army), categories.IDENT, position, 1);
	
			for _, unit in units do
				unit:SetCanBeKilled(true);
				unit:Kill();
			end
			
	end

end

swapplayer = function(playera,playerb)

	for index, currentunit in playera do
	
			if (currentunit != nil) then
					
				bp = currentunit:GetUnitId();
				
				jop = 1;
				
				if (bp == 'xsl0001') then jop = 0; end
				if (bp == 'ual0001') then jop = 0; end
				if (bp == 'url0001') then jop = 0; end
				if (bp == 'uel0001') then jop = 0; end
				
				if (jop == 1) then
				ChangeUnitArmy(currentunit,playerb)
				end
				if (jop == 0) then
				currentunit:Destroy();
				pos = currentunit:GetPosition();
				health = currentunit:GetHealth();
				
				newunit = CreateUnitHPR( bp, playerb, pos[1], pos[2], pos[3], 0,0,0);
				newunit:SetHealth(nil, health);
				
				end
						
			end
		
	end

end

nuke = function(position)
	local acu = CreateUnitHPR( "ual0001", "ARMY_SURVIVAL_ENEMY", position[1], position[2], position[3], 0,0,0);
	if (acu != nil) then
		acu:Kill();
	end
end

getUsername = function(army)
	return GetArmyBrain(army).Nickname;
end

msgOut = function(text, army)
	local color = nil;
	if (army != nil) then
		local colorIndex = ScenarioInfo.ArmySetup[army].PlayerColor;
		color = import('/lua/GameColors.lua').GameColors.ArmyColors[colorIndex];
	end
	PrintText(text, 20, color, 10, 'center') ;	
end
